// Function: processValues()
// erzeugt das Dropdown-Menu mit seinen Eintraegen und Values
// der 'leere' Zeichenbereich zwischen 127 und 159 wird uebersprungen 
function processValues(){
	for(var i=startindex;i<256;i++){
		if(i>126 && i<160)
			continue;
		var opt = document.createElement("option");
		opt.text = String.fromCharCode(i);
		opt.value = i;
		document.getElementById("popup").add(opt);
	}
}

// wird durch den Event-Handler des Popup-Menus aufgerufen
// und ermittelt den Dezimalwert des gewaehlten Zeichens.
// Das Suchfeld wird geleert und der ermittelte Wert zur Darstellung und
// Weiterverarbeitung weitergereicht
function getPopupValue(){
	var wert = document.getElementById("popup").selectedIndex+startindex;
	if(wert>126)
		wert += 33;
	document.getElementById("searchfield").value = "";
	setValues(wert);
}

// wird durch den Event-Handler des Suchfeldes aufgerufen
// und ermittelt den Dezimalwert des eingetragenen Zeichens.
// Es wird das jeweils letzte Zeichen ausgelesen und der ermittelte Wert zur Darstellung
// und Weiterverarbeitung weitergereicht.
// Wenn einer der unteren Radio-Buttons ausgewaehlt ist, wird der darunter liegende Wert
// in die Zwischenablage kopiert.
function getSearchValue(){
	var field = document.getElementById("searchfield");
	var wert = field.value;
	if(wert !=''){
		wert = trim(wert);
		setValues(wert.charCodeAt(wert.length - 1));
	}
	if(document.f.Radio[0].checked)
		copyToClipboard(document.getElementById("textfield").value);
	if(document.f.Radio[1].checked)
		copyToClipboard(document.getElementById("textfield1").value);
	if(document.f.Radio[2].checked)
		copyToClipboard(document.getElementById("textfield2").value);
}

// entfernt Leerzeichen zu Beginn und am Ende eines Textes
function trim(txt){
	txt = txt.replace(/^s+/g, '');
	txt = txt.replace(/s+$/g, '');
    return txt;
}

// setzt die Ausgabewerte
function setValues(wert){
	var hex = processHex(wert);
	document.getElementById("textfield").value = "&#" + wert + ";";
	document.getElementById("textfield2").value = "&#x" + completeNumber(hex) + ";";
	document.getElementById("textfield1").value = processEntity(hex);
}

// rechnet einen Dezimalwert in einen Hexadezimalwert um.
function processHex(z) {
	var arr = new Array();
	var rest, erg = z;
	var i = 0;
	while(erg != 0){
		arr[i] = dez2hex(erg%16);
		erg = Math.floor(erg/16);
		i++;
	}
	arr.reverse();
	return arr.join("");
}


// fuellt einen Wert von links zu einem 4-stelligen Wert mit '0' auf
function completeNumber(i){
	switch(i.length){
		case 1:
		i = "000" + i;
		case 2:
		i = "00" + i;
		break;
		case 3:
		i = "0" + i;
		break;
	}
	return i;
}


// Verwendet einen Wert zum Auslesen der Values im assoziativen Entity-Array
// Dieser wird falls vorhanden zurueck gegeben. Falls nicht vorhanden, werden '-'
// zurueck gegeben.	
function processEntity(i){

	i = completeNumber(i); 
	
	var ergebnis = arr[i];
	if(ergebnis == undefined){
		document.getElementById("textfield1").style.color = "#ff0000";
		return "      -      ";
	}
	document.getElementById("textfield1").style.color = "#000000";
	return ergebnis;
}

// Wandelt die Werte von 10 - 15 in A - F um
	function dez2hex(i){
		switch(i){
		case 10:
			i="A";
			break;
		case 11:
			i="B";
			break;
		case 12:
			i="C";
			break;
		case 13:
			i="D";
			break;
		case 14:
			i="E";
			break;
		case 15:
			i="F";
			break;
		}
		return i;
	}
	

// wird aufgerufen durch die Radiobuttons
// wenn einer der unteren Radiobuttons gewaehlt wird, wird der Eintrag in das darunter liegede 
// Textfeld in die Zwischenablage kopiert
function copyCode(elem) {
	var wert;
	
	if(elem.value == "radio" && elem.checked){
		wert = document.getElementById("textfield").value;
	}
	if(elem.value == "radio2" && elem.checked){
		wert = document.getElementById("textfield1").value;
	}
	if(elem.value == "radio4" && elem.checked){
		wert = document.getElementById("textfield2").value;
	}

	copyToClipboard(wert);
}

 // kopiert den uebergebenen Wert in die Zwischenablage
function copyToClipboard(wert){
	if(wert.indexOf('-') == -1)
		var command = widget.system("/usr/bin/php copy.php '" +	wert + "'", null);
}
	
// zeigt die Javabeginners-Webseite
function showYourwebs(){
	var websiteURL = "http://www.javabeginners.de/";
	widget.openURL(websiteURL);
} 